# coding: utf-8

"""
    IONOS Cloud - DNS API

    Cloud DNS service helps IONOS Cloud customers to automate DNS Zone and Record management.   # noqa: E501

    The version of the OpenAPI document: 1.17.0
    Contact: support@cloud.ionos.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ionoscloud_dns.configuration import Configuration


class ZoneTransferPrimaryIpStatus(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {

        'primary_ip': 'str',

        'status': 'str',

        'error_message': 'str',
    }

    attribute_map = {

        'primary_ip': 'primaryIp',

        'status': 'status',

        'error_message': 'errorMessage',
    }

    def __init__(self, primary_ip=None, status=None, error_message=None, local_vars_configuration=None):  # noqa: E501
        """ZoneTransferPrimaryIpStatus - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._primary_ip = None
        self._status = None
        self._error_message = None
        self.discriminator = None

        self.primary_ip = primary_ip
        self.status = status
        if error_message is not None:
            self.error_message = error_message


    @property
    def primary_ip(self):
        """Gets the primary_ip of this ZoneTransferPrimaryIpStatus.  # noqa: E501

        one single IP from the primaryIps field for secondary zones  # noqa: E501

        :return: The primary_ip of this ZoneTransferPrimaryIpStatus.  # noqa: E501
        :rtype: str
        """
        return self._primary_ip

    @primary_ip.setter
    def primary_ip(self, primary_ip):
        """Sets the primary_ip of this ZoneTransferPrimaryIpStatus.

        one single IP from the primaryIps field for secondary zones  # noqa: E501

        :param primary_ip: The primary_ip of this ZoneTransferPrimaryIpStatus.  # noqa: E501
        :type primary_ip: str
        """
        if self.local_vars_configuration.client_side_validation and primary_ip is None:  # noqa: E501
            raise ValueError("Invalid value for `primary_ip`, must not be `None`")  # noqa: E501

        self._primary_ip = primary_ip

    @property
    def status(self):
        """Gets the status of this ZoneTransferPrimaryIpStatus.  # noqa: E501

        Human readable status of the zone transfer status for the IP  # noqa: E501

        :return: The status of this ZoneTransferPrimaryIpStatus.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this ZoneTransferPrimaryIpStatus.

        Human readable status of the zone transfer status for the IP  # noqa: E501

        :param status: The status of this ZoneTransferPrimaryIpStatus.  # noqa: E501
        :type status: str
        """
        if self.local_vars_configuration.client_side_validation and status is None:  # noqa: E501
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501

        self._status = status

    @property
    def error_message(self):
        """Gets the error_message of this ZoneTransferPrimaryIpStatus.  # noqa: E501

        Human readable explanation of the error when status is not ok  # noqa: E501

        :return: The error_message of this ZoneTransferPrimaryIpStatus.  # noqa: E501
        :rtype: str
        """
        return self._error_message

    @error_message.setter
    def error_message(self, error_message):
        """Sets the error_message of this ZoneTransferPrimaryIpStatus.

        Human readable explanation of the error when status is not ok  # noqa: E501

        :param error_message: The error_message of this ZoneTransferPrimaryIpStatus.  # noqa: E501
        :type error_message: str
        """

        self._error_message = error_message
    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ZoneTransferPrimaryIpStatus):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ZoneTransferPrimaryIpStatus):
            return True

        return self.to_dict() != other.to_dict()
